
include ../commons/Makefile

#2048 GB
NUM = 274877906944
DRAM_ALLOC = 8589934592L
FILE = dat
BLKS_PER_RANK = 8
STAGES = 4
NODES = 128

# 64 KB
NUM = 8192
DRAM_ALLOC = 1024L
FILE = dat
BLKS_PER_RANK = 4
STAGES = 4
NODES = 16

# 256 MB
NUM = 16777216
DRAM_ALLOC = 524288L
FILE = dat
NODES = 64
BLKS_PER_RANK = 8
STAGES = 64

#--------------------
FILE = dat
NODES = 128
BLKS_PER_RANK = 32
STAGES = 32

# 1 GB
NUM = 134217728
DRAM_ALLOC = 4194304L
# 2 GB
NUM = 268435456
DRAM_ALLOC = 8388608L
# 4 GB
NUM = 536870912
DRAM_ALLOC = 16777216L
# 8 GB
NUM = 1073741824
DRAM_ALLOC = 33554432L
# 16 GB
NUM = 2147483648
DRAM_ALLOC = 67108864L
# 32 GB
NUM = 4294967296
DRAM_ALLOC = 134217728L
# 64 GB
NUM = 8589934592
DRAM_ALLOC = 268435456L
# 128 GB
NUM = 17179869184
DRAM_ALLOC = 536870912L
# 256 GB
NUM = 34359738368
DRAM_ALLOC = 1073741824L
# 512 GB
NUM = 68719476736
DRAM_ALLOC = 1073741824L

QUEUE_CMD = qsub
CORES = 1
TIME = 60
PROJECT = Performance
ENV = --env VPROF_PROFILE=yes

OPT = 2

BINARY = shuffle

CFLAGS += -O$(OPT) -g -Wall
CXX = $(CPP_BIN)
LD = $(CPP_BIN)


.c.o :
	$(CC) $(CFLAGS) $< -c

.cpp.o :
	$(CXX) $(CFLAGS) $< -c

.f.o :
	$(F90_BIN) $(CFLAGS) $< -c

.c.s :
	$(CC) $(CFLAGS) $< -S

.cpp.s :
	$(CXX) $(CFLAGS) $< -S

.f.s :
	$(F90_BIN) $(CFLAGS) $< -S


all: $(OBJ)
	$(LD) $(CFLAGS) $(OBJ) -o $(BINARY)

clean:
	rm -f $(OBJ) $(BINARY) *.error *.output *.cobaltlog
  
qsub: $(BINARY)
	$(QUEUE_CMD) -n $(NODES) --mode c$(CORES) -t $(TIME) -A $(PROJECT) $(BINARY) $(NUM) $(DRAM_ALLOC) $(SCRATCH_DIR)/data/$(NUM)_unsorted.$(FILE) $(BLKS_PER_RANK) $(STAGES)
	#$(QUEUE_CMD) -n $(NODES) --mode c$(CORES) -t $(TIME) -A $(PROJECT) $(BINARY) $(NUM) $(DRAM_ALLOC) $(SCRATCH_DIR)/data/$(NUM)_unsorted_little_endian.$(FILE) $(BLKS_PER_RANK) $(STAGES)

